package egotham.flexibleloadcontrol.SortingTechnique;

import egotham.flexibleloadcontrol.InOutAll;
import egotham.flexibleloadcontrol.Settings;

import java.util.logging.Level;
import java.util.logging.Logger;
import org.apache.commons.math3.stat.descriptive.DescriptiveStatistics;

/**
 * Implements the CalcMean method in PricePredictSort with API calls.
 *
 * @author ted
 */
public class PricePredictSortMean extends PricePredictSort {

    private Settings settings;
    private InOutAll inoutall;

    public PricePredictSortMean(InOutAll inoutall, Settings settings) {
        super(inoutall, settings);
        this.settings = settings;
        this.inoutall = inoutall;
    }

    public void setvars(Settings sett, InOutAll inout) {
        this.settings = sett;
        this.inoutall = inout;
    }

    @Override
    public double[] calcMean() {

        DescriptiveStatistics stats = new DescriptiveStatistics();
        int pricerange = settings.getStaticFuturePricerange();
        long[][] fulltariff;
        // add data
        long time = inoutall.getCurrentTime();
        for (int i = 0; i < 100 / pricerange; i++) {
            try {
                fulltariff = inoutall.gettariff(time - i * pricerange * 3600000l);
                for (int j = 0; j < pricerange; j++) {
                    stats.addValue(fulltariff[j][1]);

                }
            } //gets the prices for the last 100 hours by using the secure price range to reduce db calls. first ones to add are this hour and the next five. after that five hours prior to that etc.
            catch (Exception ex) {
                Logger.getLogger(PricePredictSortMean.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        double[] returnvalue = new double[2];
        returnvalue[0] = stats.getMean();
        returnvalue[1] = stats.getStandardDeviation();

        return returnvalue;
    }

}
