package egotham.flexibleloadcontrol.control;

import egotham.flexibleloadcontrol.InOutAllTest;
import egotham.flexibleloadcontrol.Settings;
import static junit.framework.Assert.assertEquals;
import junit.framework.TestCase;

/**
 * Tests some cases for Heater Control
 *
 * @author ted
 */
public class HeaterControlTest extends TestCase {

    public HeaterControlTest(String testName) {
        super(testName);
    }

    @Override
    protected void setUp() throws Exception {
        super.setUp();
    }

    @Override
    protected void tearDown() throws Exception {
        super.tearDown();
    }

    public void testPermitUsage() throws Exception {

        InOutAllTest inout = new InOutAllTest(1, 1); // 5 Heater + 1 Boiler, 5 Thermostats

        Settings sett = new Settings(0, 17, 23, 21, 10, 5, inout.getCurrentTime());
        int relaynumer = 1;
        int ThermostatNumber = 1;
        HeaterControl instance = new HeaterControl(relaynumer, ThermostatNumber, inout, sett);

        inout.deactivateRelay(relaynumer);  // relay inactive
        boolean use = false;                // trying to turn it off        
        boolean expResult = false;
        boolean result = instance.permitUsage(use);
        assertEquals(expResult, result);

    }

    public void testPermitUsage1() throws Exception {

        InOutAllTest inout = new InOutAllTest(1, 1); // 5 Heater + 1 Boiler, 5 Thermostats

        Settings sett = new Settings(0, 17, 23, 21, 10, 5, inout.getCurrentTime());
        int relaynumer = 1;
        int ThermostatNumber = 1;
        HeaterControl instance = new HeaterControl(relaynumer, ThermostatNumber, inout, sett);
        inout.deactivateRelay(relaynumer);  // // relay inactive, turning on 
        boolean use = true;
        boolean expResult = true;
        boolean result = instance.permitUsage(use);
        assertEquals(expResult, result);
    }

    public void testPermitUsage2() throws Exception {
        InOutAllTest inout = new InOutAllTest(1, 1); // 5 Heater + 1 Boiler, 5 Thermostats

        Settings sett = new Settings(0, 17, 23, 21, 10, 5, inout.getCurrentTime());
        int relaynumer = 1;
        int ThermostatNumber = 1;
        HeaterControl instance = new HeaterControl(relaynumer, ThermostatNumber, inout, sett);

        inout.activateRelay(relaynumer);  //  relay active, turning on 
        boolean use = true;
        boolean expResult = false;
        boolean result = instance.permitUsage(use);
        assertEquals(expResult, result);
    }

    public void testPermitUsage3() throws Exception {

        InOutAllTest inout = new InOutAllTest(1, 1); // 5 Heater + 1 Boiler, 5 Thermostats

        Settings sett = new Settings(0, 17, 23, 21, 10, 5, inout.getCurrentTime());
        int relaynumer = 1;
        int ThermostatNumber = 1;
        HeaterControl instance = new HeaterControl(relaynumer, ThermostatNumber, inout, sett);

        inout.activateRelay(relaynumer);  //  relay active, turning on 
        boolean use = false;
        boolean expResult = true;
        boolean result = instance.permitUsage(use);
        assertEquals(expResult, result);
    }
}
